--[[
	Copyright (C) Udorn (Blackhand)
--]]

local viewType = "QuestIcon"
local version = 1
local YakaGui = LibStub("YakaGui", true)
local info = YakaGui:GetViewInfo(viewType) 
if (info and info.version >= version) then 
	return 
end

qmstr = qmstr or {}
qmstr.QuestIcon = {}
qmstr.QuestIcon.prototype = {}
qmstr.QuestIcon.metatable = {__index = qmstr.QuestIcon.prototype}
setmetatable(qmstr.QuestIcon.prototype, {__index = yaka.View.prototype})

qmstr.QuestIcon.info = {viewType = viewType, version = version}
qmstr.QuestIcon.GetViewInfo = function()
	return qmstr.QuestIcon.info
end

local log = vendor.Debug:new("QuestIcon")

--[[ 
	Creates a new instance.
--]]
function qmstr.QuestIcon:new(cfgIn, parent)
	local instance = setmetatable({}, self.metatable)
	instance:InitCfg(cfgIn)
	instance:InitFrame(parent)
	return instance
end

function qmstr.QuestIcon.prototype:InitCfg(cfgIn)
	yaka.View.prototype.InitCfg(self, cfgIn)
	local cfg = self.cfg
	cfg.questIndex = cfgIn.questIndex
end

function qmstr.QuestIcon.prototype:InitFrame(parent)
	local name = self.cfg.name or "QuestMasterIcon"..YakaGui:CreateId()
	self.frame = CreateFrame("Button", name, parent, "WatchFrameItemButtonTemplate")
	yaka.View.prototype.InitFrame(self, parent)
	if (self.cfg.questIndex) then
		self:SetQuestIndex(self.cfg.questIndex)
	end
end

function qmstr.QuestIcon.prototype:SetQuestIndex(questIndex)
	self.cfg.questIndex = questIndex
	
	local link, icon, charges = GetQuestLogSpecialItemInfo(self.cfg.questIndex)
	if (icon) then
		self.frame:SetID(self.cfg.questIndex)
		self.frame.charges = charges	
		SetItemButtonTexture(self.frame, icon)
		SetItemButtonCount(self.frame, charges)
		WatchFrameItem_UpdateCooldown(self.frame)
		self.frame.rangeTimer = -1
	end
end

-- register view

YakaGui:RegisterViewType(qmstr.QuestIcon)